// codeCopyButton.js
let pre = document.querySelectorAll('pre');

pre.forEach((snippet) => {
  let button = document.createElement('button');
  button.className = 'copy-btn';


  button.addEventListener('mouseleave', clearTooltip);
  button.addEventListener('blur', clearTooltip);

  let img = document.createElement('img');
  img.className = "clippy";
  img.setAttribute('width', '13');
  img.setAttribute('src', 'https://tistory3.daumcdn.net/tistory/1888377/skin/images/clippy.svg');
  img.setAttribute('alt', 'Copy to clipboard');
  button.appendChild(img);

  snippet.appendChild(button)
});

let copyCode = new ClipboardJS('.copy-btn', {
    target: function(trigger) {
      return trigger.previousElementSibling;
    }
});

copyCode.on('success', function(event) {
    event.clearSelection();
    showTooltip(event.trigger, 'Copied');
});

copyCode.on('error', function(event) {
    showTooltip(event.trigger, fallbackMessage(event.action));
});


function clearTooltip(event) {
    event.currentTarget.setAttribute('class', 'copy-btn');
    event.currentTarget.removeAttribute('aria-label');
}

function showTooltip(elem, msg) {
    elem.setAttribute('class', 'copy-btn tooltipped tooltipped-s');
    elem.setAttribute('aria-label', msg);
}

function fallbackMessage(action) {
    let actionMsg = '';
    let actionKey = (action === 'cut' ? 'X' : 'C');
    if (/iPhone|iPad/i.test(navigator.userAgent)) {
        actionMsg = 'No support :(';
    } else if (/Mac/i.test(navigator.userAgent)) {
        actionMsg = 'Press ⌘-' + actionKey + ' to ' + action;
    } else {
        actionMsg = 'Press Ctrl-' + actionKey + ' to ' + action;
    }
    return actionMsg;
}